import { IDisposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { URI } from "@codingame/monaco-vscode-api/vscode/vs/base/common/uri";
import { IAddress } from "@codingame/monaco-vscode-bd6ad8b7-9db3-51a8-9895-0046508c029d-common/vscode/vs/platform/remote/common/remoteAgentConnection";
import { ITunnelService } from "@codingame/monaco-vscode-api/vscode/vs/platform/tunnel/common/tunnel.service";
export interface IWebviewPortMapping {
    readonly webviewPort: number;
    readonly extensionHostPort: number;
}
export declare class WebviewPortMappingManager implements IDisposable {
    private readonly _getExtensionLocation;
    private readonly _getMappings;
    private readonly tunnelService;
    private readonly _tunnels;
    constructor(_getExtensionLocation: () => URI | undefined, _getMappings: () => readonly IWebviewPortMapping[], tunnelService: ITunnelService);
    getRedirect(resolveAuthority: IAddress | null | undefined, url: string): Promise<string | undefined>;
    dispose(): Promise<void>;
    private getOrCreateTunnel;
}
